#!/usr/bin/php
<?php

require_once __DIR__.'/deubertit-nagios-php-lib/init.php';

$options = getopt("i:a:v::");
$usageString = 'usage: check_if_ip.php -i <INTERFACE> -a <ADDRESS> [-v|erbose]';
$requiredKeys = array('i', 'a');

validateParameters($options, $usageString, $requiredKeys);

# parameters

$if = $options['i'];
$address = $options['a'];

$verbose = array_key_exists('v', $options);

# do not edit below this line

if ($verbose)
{
    echo 'if: '.$if."\n";
    echo 'address: '.$address."\n";
}

/*
root@rt-keeper:/etc# ip address
1: lo: <LOOPBACK,UP,LOWER_UP> mtu 65536 qdisc noqueue state UNKNOWN group default
link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
inet 127.0.0.1/8 scope host lo
valid_lft forever preferred_lft forever
inet6 ::1/128 scope host
valid_lft forever preferred_lft forever
2: eth0: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc pfifo_fast state UP group default qlen 1000
link/ether 66:39:32:36:34:63 brd ff:ff:ff:ff:ff:ff
inet 172.30.16.100/24 brd 172.30.16.255 scope global eth0
valid_lft forever preferred_lft forever
inet6 fe80::6439:32ff:fe36:3463/64 scope link
valid_lft forever preferred_lft forever
3: eth1: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc pfifo_fast state UP group default qlen 1000
link/ether 00:50:56:00:95:9f brd ff:ff:ff:ff:ff:ff
inet 136.243.136.181/26 brd 136.243.136.191 scope global eth1
valid_lft forever preferred_lft forever
inet6 fe80::250:56ff:fe00:959f/64 scope link
valid_lft forever preferred_lft forever


root@rt-keeper:/etc# ifconfig
eth0      Link encap:Ethernet  HWaddr 66:39:32:36:34:63
          inet addr:172.30.16.100  Bcast:172.30.16.255  Mask:255.255.255.0
          inet6 addr: fe80::6439:32ff:fe36:3463/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:393948304 errors:0 dropped:0 overruns:0 frame:0
          TX packets:18324965 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:126697671661 (117.9 GiB)  TX bytes:6459971048 (6.0 GiB)

eth1      Link encap:Ethernet  HWaddr 00:50:56:00:95:9f
          inet addr:136.243.136.181  Bcast:136.243.136.191  Mask:255.255.255.192
          inet6 addr: fe80::250:56ff:fe00:959f/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:34697800 errors:0 dropped:0 overruns:0 frame:0
          TX packets:12608998 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:3674433347 (3.4 GiB)  TX bytes:3134037814 (2.9 GiB)

lo        Link encap:Local Loopback
          inet addr:127.0.0.1  Mask:255.0.0.0
          inet6 addr: ::1/128 Scope:Host
          UP LOOPBACK RUNNING  MTU:65536  Metric:1
          RX packets:2253372 errors:0 dropped:0 overruns:0 frame:0
          TX packets:2253372 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0
          RX bytes:468190605 (446.5 MiB)  TX bytes:468190605 (446.5 MiB)



root@rt-db02 /usr/lib/nagios/plugins # ip address
1: lo: <LOOPBACK,UP,LOWER_UP> mtu 65536 qdisc noqueue state UNKNOWN group default
link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
inet 127.0.0.1/8 scope host lo
valid_lft forever preferred_lft forever
inet6 ::1/128 scope host
valid_lft forever preferred_lft forever
2: eth0: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc mq state UP group default qlen 1000
link/ether 30:5a:3a:75:53:d6 brd ff:ff:ff:ff:ff:ff
inet 136.243.136.131/26 brd 136.243.136.191 scope global eth0
valid_lft forever preferred_lft forever
inet6 fe80::325a:3aff:fe75:53d6/64 scope link
valid_lft forever preferred_lft forever
3: eth1: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc mq state UP group default qlen 1000
link/ether 30:5a:3a:75:53:d7 brd ff:ff:ff:ff:ff:ff
inet 172.30.16.21/24 brd 172.30.16.255 scope global eth1
valid_lft forever preferred_lft forever
inet 172.30.16.200/32 brd 172.30.16.255 scope global eth1
valid_lft forever preferred_lft forever
inet6 fe80::325a:3aff:fe75:53d7/64 scope link
valid_lft forever preferred_lft forever


root@rt-db02 /usr/lib/nagios/plugins # ifconfig
eth0      Link encap:Ethernet  HWaddr 30:5a:3a:75:53:d6
          inet addr:136.243.136.131  Bcast:136.243.136.191  Mask:255.255.255.192
          inet6 addr: fe80::325a:3aff:fe75:53d6/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:13377691 errors:0 dropped:0 overruns:127 frame:0
          TX packets:2654984 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:9353716086 (8.7 GiB)  TX bytes:310557161 (296.1 MiB)
          Memory:fa200000-fa27ffff

eth1      Link encap:Ethernet  HWaddr 30:5a:3a:75:53:d7
          inet addr:172.30.16.21  Bcast:172.30.16.255  Mask:255.255.255.0
          inet6 addr: fe80::325a:3aff:fe75:53d7/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:388878734877 errors:0 dropped:0 overruns:4086 frame:0
          TX packets:419850295516 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:48424034960261 (44.0 TiB)  TX bytes:96467016961386 (87.7 TiB)
          Memory:fa100000-fa17ffff

lo        Link encap:Local Loopback
          inet addr:127.0.0.1  Mask:255.0.0.0
          inet6 addr: ::1/128 Scope:Host
          UP LOOPBACK RUNNING  MTU:65536  Metric:1
          RX packets:15504069 errors:0 dropped:0 overruns:0 frame:0
          TX packets:15504069 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0
          RX bytes:2832805390 (2.6 GiB)  TX bytes:2832805390 (2.6 GiB)
*/

$ipAddressOutput = null;
$ipAddressReturnVar = null;
$ipAddressExecReturn = exec('ip address show dev '.$if, $ipAddressOutput, $ipAddressReturnVar);

if ($ipAddressReturnVar != 0)
{
    echo 'ERROR: unable to execute ip address show dev '.$if."\n";
    exit($ipAddressExecReturn);
}

$ipAddressOutputString = implode("\n", $ipAddressOutput);

$ipsFoundCount = 0;
$ipsMissingCount = 0;
$ipsMissingList = array();

if (strpos($address, ',') !== false)
{
    $requiredIps = explode(',', $address);
}
else
{
    $requiredIps = array($address);
}

$ipsRequiredCount = count($requiredIps);

/*
'3: eno1: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc fq_codel state UP group default qlen 1000
    link/ether 14:da:e9:09:6b:cf brd ff:ff:ff:ff:ff:ff
    inet 192.168.23.112/24 brd 192.168.23.255 scope global dynamic noprefixroute eno1
       valid_lft 29107sec preferred_lft 29107sec
    inet6 fe80::abed:b10f:7d17:b375/64 scope link noprefixroute
       valid_lft forever preferred_lft forever'*/

// @TODO improve check quality

foreach ($requiredIps as $requiredIp)
{
    if (strpos($ipAddressOutputString, $requiredIp) === false)
    {
        $ipsMissingList[] = $requiredIp;
        $ipsMissingCount++;
    }
    else
    {
        $ipsFoundCount++;
    }
}

if ($ipsMissingCount > 0)
{
    echo 'ERROR: '.$ipsFoundCount.'/'.$ipsRequiredCount.' - address '.implode(',', $ipsMissingList).' not found for interface '.$if."\n";
    exit(STATE_CRITICAL);
}

echo 'OK: '.$ipsFoundCount.'/'.$ipsRequiredCount.' found - interface '.$if.' has matching entries for address '.implode(',', $requiredIps)."\n";
exit(STATE_OK);